.\"	$NetBSD: cdplay.1,v 1.21 2006/11/13 16:33:56 ad Exp $
.\"
.\" Copyright (c) 1999, 2000 Andrew Doran.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\" from FreeBSD: cdcontrol.1,v 1.16.2.2 1999/01/31 15:36:01 billf Exp
.\"
.Dd April 23, 2007
.Dt CDPLAY 1
.Os
.Sh NAME
.Nm cdplay
.Nd compact disc player
.Sh SYNOPSIS
.Nm cdplay
.Op Fl a Ar audio device
.Op Fl f Ar device
.Op Ar command ...
.Sh DESCRIPTION
.Nm
is a program to control the audio features of a CD-ROM drive.
.Pp
If no command is given, then
.Nm
enters interactive mode, reading commands from the standard input.
.Pp
The following options are available:
.Bl -tag -width indent
.It Fl a Ar audio device
Specify the audio device to use.
Used only in digital transfer mode.
If not specified, the environment variables
.Ev AUDIODEV
and
.Ev SPEAKER
will be tried (in this order) to find the device; as a last resort,
.Pa /dev/sound
will be used.
.It Fl f Ar device
Specify the control device to use.
Both absolute paths and paths relative to
.Pa /dev
are accepted.
The suffix
.Ql c
(or
.Ql d
on some architectures, see
.Xr disklabel 8
for details) is added to the
device name if needed.
If the device not specified, the environment variables
.Ev MUSIC_CD ,
.Ev CD_DRIVE ,
.Ev DISC
and
.Ev CDPLAY
will be tried (in this order) to find the device.
.El
.Pp
The available commands are listed below.
Only as many characters as are required to uniquely identify a command
need be specified.
The word
.Em play
can be omitted in all cases.
.Bl -tag -width Cm
.It Cm play Op Ar first_track Op Ar last_track
Play from track
.Ar first_track
to track
.Ar last_track .
The first track has number 1.
.It Cm play Op Ar start_m:start_s.start_f Op Ar end_m:end_s.end_f
Play from the absolute address
(MSF) defined by
.Ar start_m
in minutes,
.Ar start_s ,
in seconds and
.Ar start_f
(frame number) to the absolute address defined by
.Ar end_m
in minutes,
.Ar end_s ,
in seconds and
.Ar end_f
(frame number).
Minutes are in the range 0-99.
Seconds are in the range 0-59.
Frame numbers are in the range 0-74.
.It Cm play Op Ar #start_block Op length
Play starting from the logical block
.Ar start_block
using
.Ar length
logical blocks.
.It Cm next
Skip to the next track.
.It Cm prev
Skip to the previous track.
.It Cm pause
Stop playing.
Do not stop the disc.
.It Cm resume
Resume playing.
Used after the
.Em pause
command.
.It Cm shuffle
Select shuffle play.
Only valid in interactive mode.
.It Cm single Op Ar track
Pick a single track and play it repeatedly.
If a
.Ar track
argument is not given the
.Cm single
command will shut shuffle mode off and play the disc normally.
Only valid in interactive mode.
.It Cm skip
Skip to another track.
Only valid when shuffle play is selected.
.It Cm stop
Stop the disc.
.It Cm eject
Eject the disc.
.It Cm close
Inject the disc.
.It Cm volume Ar left_channel Ar right_channel
Set the volume of left channel to
.Ar left_channel
and the volume of right channel to
.Ar right_channel .
Allowed values are in the range 0-255.
.It Cm volume Ar value
Set the volume of both left channel right channel to
.Ar value .
Allowed values are in the range 0-255.
.It Cm volume mute
Turn the sound off.
.It Cm volume mono
Set the mono mode.
.It Cm volume stereo
Set the stereo mode.
.It Cm volume left
Play the left subtrack on both left and right channels.
.It Cm volume right
Play the right subtrack on both left and right channels.
.It Cm info
Print the table of contents.
.It Cm status
Display the current audio, media and volume status.
.It Cm digital Ar n
Turn on digital transfer mode.
In this mode,
.Nm
reads digital data from disc and sends it to an audio device.
A SCSI or ATAPI CD-ROM is required; and the audio device must
support CD audio format (44100 Hz sampling rate, 16-bit
stereo samples).
Audio data are read and written in groups of
.Ar n
frames (5 by default, or 1/15 seconds).
.It Cm help
Print the list of available commands.
.It Cm reset
Perform the hardware reset of the device.
.It Cm set msf
Set minute-second-frame ioctl mode (default).
.It Cm set lba
Set LBA ioctl mode.
.It Cm quit
Quit the program.
.El
.Sh FILES
.Bl -tag -width /dev/rmcd0c -compact
.It Pa /dev/cd??
.It Pa /dev/mcd??
.El
.Sh SEE ALSO
.Xr disklabel 8 ,
.Xr mscdlabel 8
.Sh HISTORY
The
.Nm
command first appeared in
.Nx 1.5 .
Support for digital transfer mode was added in
.Nx 4.0 .
